//+------------------------------------------------------------------+
//|                                                        belck.mq4 |
//|                                                   Yudintsev A.G. |
//|                                                  antpoly@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Yudintsev A.G."
#property link      "antpoly@mail.ru"
#include <stdlib.mqh>


//+------------------------------------------------------------------+
   int SOr(string sy,int op,double ll,double pp,
         double sl=0,double tp=0,int mn=0,datetime ex=0)
  {
     PlaySound("ok.wav");

   color    clOpen;
   datetime ot;
   
   double   pa,pb,mp;
   int      err,it,ticket,msl;
   string   lsComm="Exp-Belck";

   if(sy=="" || sy=="0") sy=Symbol();
   msl=MarketInfo(sy,MODE_STOPLEVEL);
   if(ex>0 && ex<TimeCurrent()) ex=0;
   for(it=1;it<=1;it++)
     {
      if(!IsTesting() && (!IsExpertEnabled() || IsStopped()))
        {
         Print("SOr():   ");
         break;
        }
      while(!IsTradeAllowed()) Sleep(5000);
      RefreshRates();
      ot=TimeCurrent();
      ticket=OrderSend(sy,op,ll,pp,MarketInfo(Symbol(),MODE_SPREAD),sl,tp,lsComm,mn,ex);
      if(ticket>0)
        {
         return(ticket);
         break;
           } else {
         err=GetLastError();
         if(err==128 || err==142 || err==143)
           {
            Sleep(1000*66);
            continue;
           }
         mp=MarketInfo(sy, MODE_POINT);
         pa=MarketInfo(sy, MODE_ASK);
         pb=MarketInfo(sy, MODE_BID);
         //  
         if(err==130)
           {
            switch(op)
              {
               case OP_BUYLIMIT:
                  if(pp>pa-msl*mp) pp=pa-msl*mp;
                  if(sl>pp-(msl+1)*mp) sl=pp-(msl+1)*mp;
                  if(tp>0 && tp<pp+(msl+1)*mp) tp=pp+(msl+1)*mp;
                  break;
               case OP_BUYSTOP:
                  if(pp<pa+(msl+1)*mp) pp=pa+(msl+1)*mp;
                  if(sl>pp-(msl+1)*mp) sl=pp-(msl+1)*mp;
                  if(tp>0 && tp<pp+(msl+1)*mp) tp=pp+(msl+1)*mp;
                  break;
               case OP_SELLLIMIT:
                  if(pp<pb+msl*mp) pp=pb+msl*mp;
                  if(sl>0 && sl<pp+(msl+1)*mp) sl=pp+(msl+1)*mp;
                  if(tp>pp-(msl+1)*mp) tp=pp-(msl+1)*mp;
                  break;
               case OP_SELLSTOP:
                  if(pp>pb-msl*mp) pp=pb-msl*mp;
                  if(sl>0 && sl<pp+(msl+1)*mp) sl=pp+(msl+1)*mp;
                  if(tp>pp-(msl+1)*mp) tp=pp-(msl+1)*mp;
                  break;
              }
            Print("SOr():   ");
           }
         //   
         if(err==2 || err==64 || err==65 || err==133)
           {
            break;
           }
         //  
         if(err==4 || err==131 || err==132)
           {
            Sleep(1000*300); break;
           }
         //    (8)     (141)
         if(err==8 || err==141) Sleep(1000*100);
         if(err==139 || err==140 || err==148) break;
         //    
         if(err==146) while(IsTradeContextBusy()) Sleep(1000*11);
         //   
         if(err==147)
           {
            ex=0; continue;
           }
         if(err!=135 && err!=138) Sleep(1000*7.7);
        }
     }
  }

//--------------------------------------------------------------------------------------------+ 
int OPs(string sy, int op, double ll, double sl=0, double tp=0, int mn=0)
  {
     PlaySound("ok.wav");

   color    clOpen;
   datetime ot;
   
   double   pp,pa,pb;
   int      dg,err,it,ticket=0;
   string   lsComm="Exp-belck";
   if(sy=="" || sy=="0") sy=Symbol();
   for(it=1;it<=1;it++)
     {
      if(!IsTesting() && (!IsExpertEnabled() || IsStopped())) break;
      while(!IsTradeAllowed()) Sleep(5000);
      RefreshRates();
      dg=MarketInfo(sy, MODE_DIGITS);
      pa=MarketInfo(sy, MODE_ASK);
      pb=MarketInfo(sy, MODE_BID);
      if(op==OP_BUY) pp=pa; else pp=pb;
      pp=NormalizeDouble(pp, dg);
      ot=TimeCurrent();
      ticket=OrderSend(sy,op,ll,pp,MarketInfo(Symbol(),MODE_SPREAD),sl,tp,lsComm,mn,0,clOpen);
      if(ticket>0)
        {
         break;
           } else {
         err=GetLastError();
         if(err==128 || err==142 || err==143)
           {
           
            Sleep(1000*3);
           }
         //    
         if(err==2 || err==64 || err==65 || err==133)
           {
         
            break;
           }
         //  
         if(err==4 || err==131 || err==132)
           {
       
            Sleep(1000*3); break;
           }
         if(err==140 || err==148 || err==4110 || err==4111) break;
         if(err==141) Sleep(1000*3);
         if(err==145) Sleep(1000*3);
         if(err==146) while(IsTradeContextBusy()) Sleep(1000*3);
         if(err!=135) Sleep(1000*3);
        }
     }
   
   return(ticket);
  }

//+---------------------------------------------------------------------+
//----------  ----------------------------------+
bool ExistPositions(string sy="", int op=-1, int mn=-1, datetime ot=0) {
  int i, k=OrdersTotal();

  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==sy || sy=="") {
        
          if (op<0 || OrderType()==op) {
            if (mn<0 || OrderMagicNumber()==mn) {
              if (ot<=OrderOpenTime()) return(True);
            
          }
        }
      }
    }
  }
  return(False);
}
//------------------------------------------------------------------------+

//+----------------------------------------------------------------------+
//           - |
//+----------------------------------------------------------------------+
bool CloseAlAferprofit(int ord, int Magic, int slip) {
     static int HistOrd,HistTime;
            int i,count;
  
  if(MagicTotalOrder(Magic, 1))  // 1 -  ,      1- , 
                                 //         .
  
  {
    HistOrd=OrdersHistoryTotal();//    
    HistTime=TimeCurrent();// 
    return;
  }  
  
  if(OrdersTotal()>0){//   
  
    if(OrdersHistoryTotal()>=HistOrd+ord){//      
      for(i=0;i<OrdersHistoryTotal();i++){// 
        if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)){// 
        if(OrderMagicNumber() == Magic){// 
          if(OrderCloseTime()>=HistTime){//     
            if(OrderClosePrice()==OrderTakeProfit()&& count == 0){//    
              count++;//  
              }
    
  }
}
}
}
}
   
    if(count>=ord){//        
      for(i=OrdersTotal()+1;i>=0;i--){
        if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
        if (OrderMagicNumber() != Magic) continue;{// 
          if(OrderType()<2){
          double price;
          if (OrderType()==OP_BUY)price=MarketInfo(OrderSymbol(),MODE_ASK);else price=MarketInfo(OrderSymbol(),MODE_BID);
                      OrderClose(OrderTicket(),OrderLots(),price,slip);//    
          }else{
            OrderDelete(OrderTicket());
          }  
        }
      }
    }
  }
 }
 for(int cnt=0;cnt<OrdersTotal();cnt++)//   
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);//      
      if( OrderSymbol()==Symbol() && OrderMagicNumber()==Magic)//    (       )
        {
         if(OrderType()==OP_BUY)//  
           {
            if(Bid > OrderTakeProfit())//     
              {
               OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet); // 
               return(0); // 
              }
           }
          if(OrderType()==OP_SELL)//  
           {
            if(Ask < OrderTakeProfit())//     
              {
               OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet); // 
               return(0); // 
              }
           }
         }
      }

//

}// end start

//====================================================================+

   bool MagicTotalOrder(int Magic,int koll_orderov) 
      {
       int i, k=OrdersTotal(),
              kol = 0;
           
       for (i=0; i < k; i++)
        {
         if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) 
         {
            if (OrderMagicNumber() == Magic) 
             kol++;
         }
        }

         if (kol < koll_orderov) return(true);
       }
//====================================================================+
//+----------------------------------------------------------------------------+
//|                .                          |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (""   -  ,                   |
//|                                     NULL -  )                 |
//|    op -                    (-1   -  )                    |
//|    mn - MagicNumber                (-1   -  )                    |
//|    ot -               ( 0   -   )          |
//+----------------------------------------------------------------------------+
bool ExistOrders(string sy="", int op=-1, int mn=-1, datetime ot=0)
{
  int k=OrdersTotal(), order_type;
 
  if (sy=="0") sy=Symbol();
  
  for  (int i=0; i < k; i++)
   {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) 
    {
      order_type = OrderType();
      
      if (order_type > 1 && order_type < 6) 
      {
        if ((OrderSymbol()==sy || sy=="") && (op < 0 || order_type == op)) 
        {
          if (OrderMagicNumber()==mn || mn < 0) 
          {
            if (ot <= OrderOpenTime()) return(True);
          }
        }
      }
    }
  }
  return(False);
} 
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 19.05.2008                                                     |
//|   :       .           |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (""   -  ,                   |
//|                                     NULL -  )                 |
//|    op -                    (-1   -  )                  |
//|    mn - MagicNumber                (-1   -  )                    |
//+----------------------------------------------------------------------------+
bool isCloseLastPosByTake(string sy="", int op=-1, int mn=-1) {
  datetime t;
  double   ocp, otp;
  int      dg, i, j=-1, k=OrdersHistoryTotal();

  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_HISTORY)) {
      if (OrderSymbol()==sy) {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (OrderType()==op) {
            if (OrderMagicNumber()==mn) {
              if (t<OrderCloseTime()) {
                t=OrderCloseTime();
                j=i;
              }
            }
          }
        }
      }
    }
  }
  if (OrderSelect(j, SELECT_BY_POS, MODE_HISTORY)) {
    dg=MarketInfo(sy, MODE_DIGITS);
    if (dg==0) if (StringFind(OrderSymbol(), "JPY")<0) dg=4; else dg=2;
    ocp=NormalizeDouble(OrderClosePrice(), dg);
    otp=NormalizeDouble(OrderTakeProfit(), dg);
    if (ocp==otp) return(True);
  }
  return(False);
}

//+----------------------------------------------------------------------------+
//+----------------------------------------------------------------------------+
//|     :   . aka KimIV,  http://www.kimiv.ru                    |
//+----------------------------------------------------------------------------+
//|    : 28.11.2006                                                      |
//|  :                                                  |
//+----------------------------------------------------------------------------+
//| :                                                                 |
//|   sy -     ( ""  -  ,                    |
//|                                    NULL -  )                  |
//|   op -                    (  -1 -  )                     |
//|   mn - MagicNumber                (  -1 -  )                     |
//+----------------------------------------------------------------------------+
void Delete_Orders(string sy="", int op=-1, int mn=-1) {
  bool fd;
  int err, i, it, k=OrdersTotal(), ot;
  int NumberOfTry = 5; // .
  
  
  if (sy=="0") sy=Symbol();
  for (i=k-1; i>=0; i--) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      ot=OrderType();
      if (ot>1 && ot<6) {
        if ((OrderSymbol()==sy || sy=="") && (op<0 || ot==op)) {
          if (mn<0 || OrderMagicNumber()==mn) {
          
            for (it=1; it<=NumberOfTry; it++) {
              if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) break;
              while (!IsTradeAllowed()) Sleep(5000);
              fd=OrderDelete(OrderTicket(), CLR_NONE);
              if (fd) break; //  , .
                            
              else {
                err=GetLastError();
                Print("Error(",err,") delete order ",": ",ErrorDescription(err),", try ",it);
                Sleep(1000*5);
              }
            }
          }
        }
      }
    }
  }
}
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 19.02.2008                                                     |
//|   :   .                                 |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (""   -  ,                   |
//|                                     NULL -  )                 |
//|    op -                    (-1   -  )                  |
//|    mn - MagicNumber                (-1   -  )                    |
//+----------------------------------------------------------------------------+
int NumberOfPositions(string sy="", int op=-1, int mn=-1) {
  int i, k=OrdersTotal(), kp=0;

  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==sy || sy=="") {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (op<0 || OrderType()==op) {
            if (mn<0 || OrderMagicNumber()==mn) kp++;
          }
        }
      }
    }
  }
  return(kp);
}
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (""   -  ,                   |
//|                                     NULL -  )                 |
//|    op -                    (-1   -  )                  |
//|    mn - MagicNumber                (-1   -  )                    |
//+----------------------------------------------------------------------------+
void ClosePositions(string sy="", int op=-1, int mn=-1) {
  int i, k=OrdersTotal();

  if (sy=="0") sy=Symbol();
  
  for (i=k-1; i>=0; i--) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if ((OrderSymbol()==sy) && (op<0 || OrderType()==op)) {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (OrderMagicNumber()==mn) ClosePosBySelect();
        }
      }
    }
  }
}
//-----------------------------------------------------------------------------+
void ClosePosBySelect() {
  bool   fc;
  color  clClose;
  double ll, pa, pb, pp;
  int    err, it, NumberOfTry = 5;

  if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
    
    for (it=1; it<=NumberOfTry; it++) {
      if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) break;
      while (!IsTradeAllowed()) Sleep(5000);
      RefreshRates();
      pa=MarketInfo(OrderSymbol(), MODE_ASK);
      pb=MarketInfo(OrderSymbol(), MODE_BID);
      if (OrderType()==OP_BUY) {
        pp=pb; 
      } else {
        pp=pa; 
      }
      ll=OrderLots();
      fc=OrderClose(OrderTicket(), ll, pp, 3, CLR_NONE);
      if (fc) {
         break;
      } else {
        err=GetLastError();
        if (err==146) while (IsTradeContextBusy()) Sleep(1000*11);
        Print("Error(",err,") Close "," ",
              ErrorDescription(err),", try ",it);
              
        Print(OrderTicket(),"  Ask=",pa,"  Bid=",pb,"  pp=",pp);
        Print("sy=",OrderSymbol(),"  ll=",ll,"  sl=",OrderStopLoss(),
              "  tp=",OrderTakeProfit(),"  mn=",OrderMagicNumber());
        Sleep(1000*5);
      }
    }
  } else Print("  . Close ");
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 19.02.2008                                                     |
//|   :         |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (""   -  ,                   |
//|                                     NULL -  )                 |
//|    op -                    (-1   -  )                  |
//|    mn - MagicNumber                (-1   -  )                    |
//+----------------------------------------------------------------------------+
double GetProfitOpenPosInCurrency(string sy="", int op=-1, int mn=-1) {
  double p=0;
  int    i, k=OrdersTotal();

  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if ((OrderSymbol()==sy || sy=="") && (op<0 || OrderType()==op)) {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (mn<0 || OrderMagicNumber()==mn) {
            p+=OrderProfit()+OrderCommission()+OrderSwap();
          }
        }
      }
    }
  }
  return(p);
}